<?php
    # ----------------------------------------------------------------------------
    # PRJ_ROOT/smarty/cfg/smarty.php - the SMARTY cfg w/the least changes
    # Created: 19.09.2018 17:12:19Z by pieli
    # Updated: 30.04.2020 by pieli
    # ----------------------------------------------------------------------------
    # defines: configure your project here!
    # ----------------------------------------------------------------------------
    define('SYSTEM',    'default'); // what system are you on?
    define('SMARTY_VER','3.1.34');  // what smarty ver will you pick?
    define('SMARTY_ROOT','/var/php-utils/smarty');  // what smarty path will you pick?

    # ----------------------------------------------------------------------------
    # no need for changes beyond this point!
    # ----------------------------------------------------------------------------
    define('SMARTY_DIR', SMARTY_ROOT . '/smarty-' . SMARTY_VER . '/libs/');
    //~ define('SMARTY_DIR','K:/bin/uwamp/www/smarty/vendor/smarty-' . SMARTY_VER . '/libs/');

    # ----------------------------------------------------------------------------
    # find out path for project
    # ----------------------------------------------------------------------------
    $trenners = array('default' => '/','windows' => '\\');
    $segments = explode($trenners[SYSTEM],__FILE__);
    array_pop($segments);
    array_pop($segments);
    array_pop($segments);
    define('PRJ_ROOT',implode($trenners[SYSTEM],$segments));

    # ----------------------------------------------------------------------------
    # house keep, only CONSTANSTS will survive
    # ----------------------------------------------------------------------------
    unset($segments);
    unset($trenners);

    # ----------------------------------------------------------------------------
    # load SMARTY library
    # ----------------------------------------------------------------------------
    require_once(SMARTY_DIR . 'Smarty.class.php');
    $smarty = new Smarty;

    # ----------------------------------------------------------------------------
    # set SMARTY defaults
    # ----------------------------------------------------------------------------
    $smarty->setTemplateDir( PRJ_ROOT . '/smarty/templates/' );
    $smarty->setCompileDir( PRJ_ROOT . '/smarty/templates_c/' );
    $smarty->setConfigDir( PRJ_ROOT . '/smarty/cfg/' );
    $smarty->setCacheDir( PRJ_ROOT . '/smarty/cache/' );

    # ----------------------------------------------------------------------------
    # after requiring this, smarty is loaded, confed and good to go!
    # ----------------------------------------------------------------------------
?>
