<?php
# ----------------------------------------------------------------------------
# INIT: Die dB-Zugänge
# ----------------------------------------------------------------------------
	require_once('../cfg/db.php');

	$today = date("Y-m-d 00:00:00");
	$errors = array();
	$users = array();
	$cost = 11;
	$submitLabel = 'Chat-Nutzer in der db anlegen';

# ----------------------------------------------------------------------------
# Verbindungsaufbau (waere gar nicht so schlecht ...)
# ----------------------------------------------------------------------------
	$dB = new PDO('mysql:host=' . MYSQL_HOST . ';dbname=' . MYSQL_DB . ';charset=utf8', MYSQL_USER, MYSQL_PASS) OR die('No MySQL!');

# ----------------------------------------------------------------------------
# msg speichern
# ----------------------------------------------------------------------------
	if(isset($_POST['submit'])) {
		if(strlen(trim($_POST['pass'])) > 0) {
			$sql = "INSERT INTO users (user, salt, hash) VALUES (?, ?, ?);";
			$stmt = $dB->prepare($sql);
			$user = $_POST['user'];
			$pass = $_POST['pass'];
			
			/* To generate the salt, first generate enough random bytes. Because
			 * base64 returns one character for each 6 bits, the we should generate
			 * at least 22*6/8=16.5 bytes, so we generate 17. Then we get the first
			 * 22 base64 characters
			 */
			$salt = substr(base64_encode(openssl_random_pseudo_bytes(17)),0,22);

			/* As blowfish takes a salt with the alphabet ./A-Za-z0-9 we have to
			 * replace any '+' in the base64 string with '.'. We don't have to do
			 * anything about the '=', as this only occurs when the b64 string is
			 * padded, which is always after the first 22 characters.
			 */
			$salt = str_replace("+",".",$salt);

			/* Next, create a string that will be passed to crypt, containing all
			 * of the settings, separated by dollar signs
			 */
			$param = '$'.implode('$',array(
								"2y", //select the most secure version of blowfish (>=PHP 5.3.7)
								str_pad($cost,2,"0",STR_PAD_LEFT), //add the cost in two digits
								$salt //add the salt
				));
			 
			//now do the actual hashing
			$hash = crypt($pass,$param);

			if($stmt->execute(array($user, $salt, $hash))) { # Fehlertoleranz für den db-Schreiberich; db gut
				$users[] = array(
					'user' => $user,
					'hash' => $hash,
					'salt' => $salt,
					'pass' => $pass
				);

			} else { # db schlecht
				$dbE = $stmt->errorInfo();
				$errors[] = 'Die databse hat heute frei, rufen Sie 110 / Feurio!';
				$errors[] = 'Die dB sagt: ' . array_pop($dbE) . '!';
			}
		}
	}

# ----------------------------------------------------------------------------
# SMARTY
# ----------------------------------------------------------------------------
	require_once('../smarty/cfg/setup.php');
	
# ----------------------------------------------------------------------------
# templating
# ----------------------------------------------------------------------------
	$smarty->assign('ver', VERSION);    # VERSION
	$smarty->assign('submit', $submitLabel);    # absenden-Knopf
	$smarty->assign('users', $users);   # error-msgs fuers schreiben
	$smarty->assign('errors', $errors); # error-msgs fuers schreiben
	$smarty->display('adduser.tpl');    # wie immer
?>
